/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Text;


public class Evaluable extends Composite {
	private Label labelGrupo;
	private Label labelParcial;
	private Label labelTipo;
	private Label labelReferencia;
	private Label labelEnunciado;
	private Label labelPeso;
	private Label labelInicioHora;
	private Label labelFinHora;
	private Text textReferencia;public Text getTextReferencia(){return textReferencia;}
	private Text textPeso;public Text getTextPeso(){return textPeso;}
	private Text textAreaEnunciado;public Text getTextAreaEnunciado(){return textAreaEnunciado;}
	private List listEvaluables;
	private Combo comboParcial;
	private Combo comboTipo;
	private Combo comboInicioFecha;
	private Combo comboInicioHora;
	private Combo comboFinHora;
	private Combo comboFinFecha;
	private Group groupSeleccion;
	private Composite compositeAcciones;
	private Group groupContenido;
	private Group groupCuando;
	private Group groupInicio;
	private Group groupFin;
	private Group groupEvaluaciones;
	private Button buttonNueva;
	private Button buttonBorrar;
	private List listEvaluacionesEstudiantes;
	private List listEvaluacionesGrupos;
	private Label labelEvaluacionesNota;
	private Text textEvaluacionesNota;public Text getTextEvaluacionesNota(){return textEvaluacionesNota;}
	private Label labelEvaluacionesObservaciones;
	private Label labelEvaluacionesMoverA;
	private Text textAreaEvaluacionesObservaciones;public Text getTextAreaEvaluacionesObservaciones(){return textAreaEvaluacionesObservaciones;}
	private Group groupEvaluacionesGrupo;
	private Group groupEvaluacionesEstudiantes;
	private Button buttonEvaluacionesNuevoGrupo;
	private Button buttonEvaluacionesBorrarGrupo;
	private Combo comboEvaluacionesMoverA;
	private ComboConId comboConIdMateriaClase;
	private ListConId listConIdEvaluables;
	private ComboConId comboConIdTipo;
	private FechaCombo fechaComboFin;
	private FechaCombo fechaComboInicio;
	private UHCombo uHComboInicio;
	private UHCombo uHComboFin;
	private ListConId listConIdEvaluacionesEstudiantes;
	private ListConId listConIdEvaluacionesGrupos;
	private Text textEvaluacionGrupoNombre;
	private Label labelReferenciaGrupo = null;
	private ComboConId comboConIdEvaluacionesMoverA;
	private Composite composite;public Text getTextEvaluacionGrupoNombre(){return textEvaluacionGrupoNombre;}
	public Evaluable(Composite parent, int style) {super(parent, style);initialize();}
	public void actualizar(){
		comboConIdMateriaClase.rellenarMateriaClase(false);
		comboConIdMateriaClase.seleccionarId(MateriaClase.getIdMateriaClaseDeTrabajo());
		comboConIdTipo.rellenarTipoEvaluable(MateriaClase.getIdMateriaDeTrabajo());		
		Parcial.rellenarParciales(comboParcial);
		actualizarFechaEvaluables();
		actualizarListaEvaluables(null);
	}
	private void initialize() {
		GridLayout gridLayoutEvaluable = new GridLayout();
		gridLayoutEvaluable.horizontalSpacing = 2;
		gridLayoutEvaluable.verticalSpacing = 2;
		gridLayoutEvaluable.marginWidth = 2;
		gridLayoutEvaluable.marginHeight = 2;
		gridLayoutEvaluable.numColumns = 2;
		GridData gridDataEvaluable = new GridData();
		gridDataEvaluable.grabExcessHorizontalSpace = true;
		gridDataEvaluable.grabExcessVerticalSpace = true;
		gridDataEvaluable.horizontalAlignment = GridData.FILL;
		gridDataEvaluable.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataEvaluable);
		this.setLayout(gridLayoutEvaluable);
		this.setSize(new Point(685, 340));
		createGroupSeleccion();
		createGroupCuando();
		createGroupEvaluaciones();
		createGroupContenido();
	}
	private void createGroupSeleccion() {
		GridLayout gridLayoutGroupSeleccion = new GridLayout();
		gridLayoutGroupSeleccion.numColumns = 3;
		gridLayoutGroupSeleccion.verticalSpacing = 2;
		gridLayoutGroupSeleccion.marginWidth = 2;
		gridLayoutGroupSeleccion.marginHeight = 2;
		gridLayoutGroupSeleccion.horizontalSpacing = 2;
		GridData gridDataGroupSeleccion = new GridData();
		gridDataGroupSeleccion.widthHint = 300;
		gridDataGroupSeleccion.horizontalAlignment = GridData.FILL;
		gridDataGroupSeleccion.grabExcessVerticalSpace = true;
		gridDataGroupSeleccion.grabExcessHorizontalSpace = true;
		gridDataGroupSeleccion.verticalSpan = 2;
		gridDataGroupSeleccion.verticalAlignment = GridData.FILL;
		groupSeleccion = new Group(this, SWT.NONE);
		groupSeleccion.setToolTipText("");
		groupSeleccion.setText("Item Evaluable");
		groupSeleccion.setLayoutData(gridDataGroupSeleccion);
		groupSeleccion.setLayout(gridLayoutGroupSeleccion);
		labelGrupo = new Label(groupSeleccion, SWT.NONE);
		labelGrupo.setText("Grupo:");
		labelGrupo.setToolTipText("Elija la clase sobre la que ver, modificar, crear o borrar las activiadades.");
		GridData gridDataLabelParcial = new GridData();
		gridDataLabelParcial.grabExcessHorizontalSpace = false;
		gridDataLabelParcial.verticalAlignment = GridData.END;
		gridDataLabelParcial.horizontalAlignment = GridData.CENTER;
		createComboGrupoMateria();
		listEvaluables = new List(groupSeleccion, SWT.BORDER | SWT.V_SCROLL);
		listEvaluables.setToolTipText("Elegir el item evaluable sobre la que ver, modificar o crear información.");
		labelParcial = new Label(groupSeleccion, SWT.NONE);
		labelParcial.setLayoutData(gridDataLabelParcial);
		labelParcial.setText("Parcial:");
		labelParcial.setToolTipText("Elegir el parcial sobre el que ver, modificar o crear elementos evaluables.");
		createComboParcial();
		createGroupAcciones();
		GridData gridDataListEvaluables = new GridData();
		gridDataListEvaluables.minimumHeight = 50;
		gridDataListEvaluables.horizontalAlignment = GridData.FILL;
		gridDataListEvaluables.verticalAlignment = GridData.FILL;
		gridDataListEvaluables.grabExcessHorizontalSpace = true;
		gridDataListEvaluables.horizontalSpan = 2;
		gridDataListEvaluables.verticalSpan = 3;
		gridDataListEvaluables.grabExcessVerticalSpace = true;
		listEvaluables.setLayoutData(gridDataListEvaluables);
		listEvaluables
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {   
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						actualizarDatosEvaluable();
					}
				});
		listConIdEvaluables = new ListConId(listEvaluables);
	}
	private void createComboGrupoMateria() {
		GridData gridDataComboGrupoMateria = new GridData();
		gridDataComboGrupoMateria.widthHint = 100;
		gridDataComboGrupoMateria.horizontalAlignment = GridData.FILL;
		gridDataComboGrupoMateria.horizontalSpan = 2;
		gridDataComboGrupoMateria.verticalAlignment = GridData.CENTER;
		Combo comboMateriaClase = new Combo(groupSeleccion,SWT.READ_ONLY);
		comboMateriaClase.setText("9ºXXXXX");
		comboMateriaClase.setToolTipText("Elija aquí la clase sobre la que ver, modificar, crear o borrar las activiadades.");
		comboMateriaClase.setLayoutData(gridDataComboGrupoMateria);
		comboMateriaClase
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Cambiando MateriaClase");
						MateriaClase.fijarMateriaClase(comboConIdMateriaClase.idSeleccionado());
						if (!BBDD.consultarUHvacio(comboConIdMateriaClase.idSeleccionado())){
							Parcial.rellenarParciales(comboParcial);
						} else {
							comboParcial.removeAll();
						}
						comboConIdTipo.rellenarTipoEvaluable(MateriaClase.getIdMateriaDeTrabajo());		
						Parcial.rellenarParciales(comboParcial);
						actualizarFechaEvaluables();
						actualizarListaEvaluables(null);
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboMateriaClase.setToolTipText("Seleccione el grupo de estudiantes y la materia sobre los que quiere trabajar.");
		comboConIdMateriaClase = new ComboConId(comboMateriaClase);
	}
	private void createComboParcial() {
		GridData gridDataComboParcial = new GridData();
		gridDataComboParcial.widthHint = 50;
		gridDataComboParcial.verticalAlignment = GridData.BEGINNING;
		gridDataComboParcial.grabExcessVerticalSpace = true;
		gridDataComboParcial.horizontalAlignment = GridData.CENTER;
		comboParcial = new Combo(groupSeleccion,SWT.READ_ONLY);
		comboParcial.setText("9");
		comboParcial.setToolTipText("Elegir el parcial sobre el que ver, modificar o crear elementos evaluables.");
		comboParcial.setLayoutData(gridDataComboParcial);
		comboParcial
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Cambiando Parcial");
						actualizarFechaEvaluables();
						actualizarListaEvaluables(null);
						listConIdEvaluables.seleccionarId(null);
						actualizarDatosEvaluable();
						Parcial.setParcialDeTrabajo(comboParcial.getSelectionIndex()+1);
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		comboParcial.setToolTipText("Seleccione el parcial sobre el que quiere trabajar.");
	}
	private void createGroupAcciones() {
		GridData gd_compositeAcciones = new GridData();
		gd_compositeAcciones.horizontalAlignment = GridData.BEGINNING;
		gd_compositeAcciones.verticalAlignment = GridData.END;
		GridLayout gl_compositeAcciones = new GridLayout();
		gl_compositeAcciones.horizontalSpacing = 2;
		gl_compositeAcciones.marginWidth = 2;
		gl_compositeAcciones.marginHeight = 2;
		gl_compositeAcciones.numColumns = 1;
		gl_compositeAcciones.verticalSpacing = 2;
		compositeAcciones = new Composite(groupSeleccion, SWT.NONE);
		compositeAcciones.setLayout(gl_compositeAcciones);
		compositeAcciones.setLayoutData(gd_compositeAcciones);
		buttonNueva = new Button(compositeAcciones, SWT.NONE);
		buttonNueva.setText("Nueva");
		buttonNueva.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Creando Evaluable");
				if (comboConIdMateriaClase.numeroElementos().equals(0)) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber creado una materia y una clase para un nivel.");
				} else if (comboConIdMateriaClase.idSeleccionado()==null) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber seleccionado una materia-clase.");
				} else if (BBDD.consultarUHvacio(MateriaClase.getIdMateriaClaseDeTrabajo())) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber creado una unidad horaria en la pestaña 'Horario' para la materia-clase seleccionada.");
				} else if (comboParcial.getItemCount()==0) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber creado al menos un parcial en la pestaña 'Mantenimiento' para la materia seleccionada.");
				} else if (comboParcial.getSelectionIndex()<0) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber seleccionado un parcial.");
				} else if (comboConIdTipo.numeroElementos().equals(0)) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber creado una tipo de ítem evaluable genérico o especifico para esta materia en la pestaña 'Mantenimiento'.");
				} else {
					String tipo=comboConIdTipo.idSeleccionado();
					if (tipo==null) tipo=comboConIdTipo.primerId();
					String id=BBDD.insertarEvaluable(tipo);
					Vector<Vector<String>> evaluable=BBDD.consultarEvaluable(id);
					Calendar fecha=Fecha.fecha(evaluable.get(0).get(7), evaluable.get(0).get(6), evaluable.get(0).get(5));
					int parcial=Parcial.getParcial(fecha);
					//System.out.println("c="+(comboParcial.getSelectionIndex()+1)+" p="+parcial);
					if ((comboParcial.getSelectionIndex()+1)!=parcial) {
						comboParcial.select(parcial-1);
					}
					//System.out.println("c="+(comboParcial.getSelectionIndex()+1));
					actualizarListaEvaluables(id);
					//PCuaderno.MiPCuaderno.grupoClase.listarEstudiantesNota();
					textReferencia.setFocus();
				}
			}
		});
		buttonBorrar = new Button(compositeAcciones, SWT.NONE);
		buttonBorrar.setText("Borrar");
		buttonBorrar.setToolTipText("Pulse aquí para borrar el elemento evaluable seleccionada.");
		buttonBorrar
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Borrando Evaluable");
						BBDD.borrarEvaluable(listConIdEvaluables.idSeleccionado());
						actualizarListaEvaluables(null);
						//PCuaderno.MiPCuaderno.grupoClase.listarEstudiantesNota();
					}
				});
	}
	private void createGroupContenido() {
		GridLayout gridLayoutgroupContenido = new GridLayout();
		gridLayoutgroupContenido.verticalSpacing = 2;
		gridLayoutgroupContenido.marginWidth = 2;
		gridLayoutgroupContenido.marginHeight = 2;
		gridLayoutgroupContenido.horizontalSpacing = 2;
		GridData gridDataGroupContenido = new GridData();
		gridDataGroupContenido.widthHint = 300;
		gridDataGroupContenido.minimumHeight = 50;
		gridDataGroupContenido.horizontalAlignment = GridData.FILL;
		gridDataGroupContenido.grabExcessHorizontalSpace = true;
		gridDataGroupContenido.grabExcessVerticalSpace = true;
		gridDataGroupContenido.verticalAlignment = GridData.FILL;
		groupContenido = new Group(this, SWT.NONE);
		groupContenido.setText("Contenido");
		groupContenido.setLayout(gridLayoutgroupContenido);
		groupContenido.setLayoutData(gridDataGroupContenido);
		createComboTipo();
		GridData gridDataLabelEnunciado = new GridData();
		gridDataLabelEnunciado.verticalAlignment = GridData.END;
		gridDataLabelEnunciado.horizontalAlignment = GridData.BEGINNING;
		labelEnunciado = new Label(groupContenido, SWT.NONE);
		labelEnunciado.setText("Enunciado:");
		labelEnunciado.setToolTipText("Especifique el enunciado o la descripción de la activiadad.");
		labelEnunciado.setLayoutData(gridDataLabelEnunciado);
		GridData gridDataTextAreaEnunciado = new GridData();
		gridDataTextAreaEnunciado.heightHint = 15;
		gridDataTextAreaEnunciado.horizontalAlignment = GridData.FILL;
		gridDataTextAreaEnunciado.verticalAlignment = GridData.FILL;
		gridDataTextAreaEnunciado.grabExcessHorizontalSpace = true;
		gridDataTextAreaEnunciado.grabExcessVerticalSpace = true;
		textAreaEnunciado = new Text(groupContenido, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		textAreaEnunciado.setToolTipText("Especifique el enunciado o la descripción de la activiadad.");
		textAreaEnunciado.setLayoutData(gridDataTextAreaEnunciado);
		TextoDemorado.add(textAreaEnunciado,false,512,null,null,true,listConIdEvaluables,null);
	}
	private void createComboTipo() {
		
		composite = new Composite(groupContenido, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite = new GridLayout(6, false);
		gl_composite.verticalSpacing = 2;
		gl_composite.marginWidth = 2;
		gl_composite.marginHeight = 2;
		gl_composite.horizontalSpacing = 2;
		composite.setLayout(gl_composite);
		labelTipo = new Label(composite, SWT.NONE);
		labelTipo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelTipo.setText("Tipo:");
		labelTipo.setToolTipText("Elegir el tipo del elemento evaluable. Los tipos se permitiran agrupar la nota obtenida con otras del mismo tipo, asignandole un peso dento de este grupo.");
		comboTipo = new Combo(composite,SWT.READ_ONLY);
		GridData gd_comboTipo = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboTipo.widthHint = 20;
		comboTipo.setLayoutData(gd_comboTipo);
		comboTipo.setText("XXX");
		comboTipo.setToolTipText("Elegir el tipo del elemento evaluable. Los tipos se permitiran agrupar la nota obtenida con otras del mismo tipo, asignandole un peso dento de este grupo.");
		comboTipo.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				//System.out.println("Tipo = "+comboConIdTipo.eSeleccionado()+ "("+comboConIdTipo.idSeleccionado()+")");
				BBDD.modificarTipoDeEvaluable(listConIdEvaluables.idSeleccionado(),comboConIdTipo.idSeleccionado());
				actualizarSoloListaEvaluables();
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		comboConIdTipo = new ComboConId(comboTipo);
		labelReferencia = new Label(composite, SWT.NONE);
		labelReferencia.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelReferencia.setText("Ref.:");
		labelReferencia.setToolTipText("Especifique una abreviatura para referirse a este elemento evaluable en concreto. No repita el tipo.");
		textReferencia = new Text(composite, SWT.BORDER);
		GridData gd_textReferencia = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textReferencia.widthHint = 20;
		textReferencia.setLayoutData(gd_textReferencia);
		textReferencia.setToolTipText("Especifique una abreviatura para referirse a este elemento evaluable en concreto. No repita el tipo.");
		TextoDemorado.add(textReferencia,false,8,null,null,false,listConIdEvaluables,null);
		labelPeso = new Label(composite, SWT.NONE);
		labelPeso.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelPeso.setText("Peso:");
		labelPeso.setToolTipText("Especifique un peso para este elemento evaluable en concreto dentro el grupo de elementos evaluables del mismo tipo.");
		textPeso = new Text(composite, SWT.BORDER);
		GridData gd_textPeso = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_textPeso.widthHint = 20;
		textPeso.setLayoutData(gd_textPeso);
		textPeso.setToolTipText("Especifique un peso para este elemento evaluable en concreto dentro el grupo de elementos evaluables del mismo tipo.");
		TextoDemorado.add(textPeso,true,3,null,null,false,listConIdEvaluables,null);
	}
	private void createGroupCuando() {
		GridLayout gridLayoutGroupCuando = new GridLayout();
		gridLayoutGroupCuando.horizontalSpacing = 2;
		gridLayoutGroupCuando.marginWidth = 2;
		gridLayoutGroupCuando.marginHeight = 2;
		gridLayoutGroupCuando.numColumns = 2;
		gridLayoutGroupCuando.verticalSpacing = 2;
		GridData gridDataGroupCuando = new GridData();
		gridDataGroupCuando.widthHint = 300;
		gridDataGroupCuando.horizontalAlignment = GridData.FILL;
		gridDataGroupCuando.grabExcessHorizontalSpace = true;
		gridDataGroupCuando.verticalAlignment = GridData.FILL;
		groupCuando = new Group(this, SWT.NONE);
		groupCuando.setText("Cuando");
		createGroupInicio();
		groupCuando.setLayoutData(gridDataGroupCuando);
		groupCuando.setLayout(gridLayoutGroupCuando);
		createGroupFin();
	}
	private void createGroupInicio() {
		GridData gridDataGroupInicio = new GridData();
		gridDataGroupInicio.grabExcessHorizontalSpace = true;
		gridDataGroupInicio.verticalAlignment = GridData.FILL;
		gridDataGroupInicio.horizontalAlignment = GridData.FILL;
		GridLayout gridLayoutGroupInicio = new GridLayout();
		gridLayoutGroupInicio.numColumns = 2;
		gridLayoutGroupInicio.verticalSpacing = 2;
		gridLayoutGroupInicio.marginWidth = 2;
		gridLayoutGroupInicio.marginHeight = 2;
		gridLayoutGroupInicio.horizontalSpacing = 2;
		groupInicio = new Group(groupCuando, SWT.NONE);
		groupInicio.setText("Inicio");
		groupInicio.setLayoutData(gridDataGroupInicio);
		groupInicio.setLayout(gridLayoutGroupInicio);
		createComboInicioFecha();
		labelInicioHora = new Label(groupInicio, SWT.NONE);
		labelInicioHora.setText("Hora:");
		createComboInicioHora();
	}
	private void createComboInicioFecha() {
		GridData gridDataComboInicioFecha = new GridData();
		gridDataComboInicioFecha.horizontalAlignment = GridData.FILL;
		gridDataComboInicioFecha.grabExcessHorizontalSpace = true;
		gridDataComboInicioFecha.widthHint = 100;
		gridDataComboInicioFecha.horizontalSpan = 2;
		gridDataComboInicioFecha.verticalAlignment = GridData.CENTER;
		comboInicioFecha = new Combo(groupInicio,SWT.READ_ONLY);
		comboInicioFecha.setText("00/00/0000");
		comboInicioFecha.setLayoutData(gridDataComboInicioFecha);
		comboInicioFecha
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						uHComboInicio.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboInicio.fechaSeleccionada(),null);
						fechaComboFin.rellenarLectivosParcialDesdeFechaMateria(comboParcial.getSelectionIndex()+1,fechaComboInicio.fechaSeleccionada(), true);
						if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
							uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
						else
							uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),null);
						BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
								fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
								fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
						actualizarListaEvaluables(null);
					}
					public void widgetDefaultSelected(
							org.eclipse.swt.events.SelectionEvent e) {
					}
				});
		fechaComboInicio = new FechaCombo(comboInicioFecha);
	}
	private void createComboInicioHora() {
		GridData gridDataComboInicioHora = new GridData();
		gridDataComboInicioHora.grabExcessHorizontalSpace = true;
		gridDataComboInicioHora.verticalAlignment = GridData.CENTER;
		gridDataComboInicioHora.widthHint = 100;
		gridDataComboInicioHora.horizontalAlignment = GridData.FILL;
		comboInicioHora = new Combo(groupInicio, SWT.READ_ONLY);
		comboInicioHora.setText("00:00-00:00");
		comboInicioHora.setLayoutData(gridDataComboInicioHora);
		comboInicioHora
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
							uHComboFin.rellenaUHMateriaClaseDesdeHora(comboConIdMateriaClase.idSeleccionado(), fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
						BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
								fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
								fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
						actualizarListaEvaluables(null);
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		uHComboInicio = new UHCombo(comboInicioHora);
	}
	private void createGroupFin() {
		GridLayout gridLayoutGroupFin = new GridLayout();
		gridLayoutGroupFin.numColumns = 2;
		gridLayoutGroupFin.verticalSpacing = 2;
		gridLayoutGroupFin.marginWidth = 2;
		gridLayoutGroupFin.marginHeight = 2;
		gridLayoutGroupFin.horizontalSpacing = 2;
		GridData gridDataGroupFin = new GridData();
		gridDataGroupFin.horizontalAlignment = GridData.FILL;
		gridDataGroupFin.grabExcessVerticalSpace = false;
		gridDataGroupFin.grabExcessHorizontalSpace = true;
		gridDataGroupFin.verticalAlignment = GridData.FILL;
		groupFin = new Group(groupCuando, SWT.NONE);
		groupFin.setText("Fin");
		groupFin.setLayout(gridLayoutGroupFin);
		groupFin.setLayoutData(gridDataGroupFin);
		createComboFinFecha();
		labelFinHora = new Label(groupFin, SWT.NONE);
		labelFinHora.setText("Hora:");
		createComboFinHora();
	}
	private void createComboFinFecha() {
		GridData gridDataComboFinFecha = new GridData();
		gridDataComboFinFecha.horizontalAlignment = GridData.FILL;
		gridDataComboFinFecha.grabExcessHorizontalSpace = true;
		gridDataComboFinFecha.widthHint = 100;
		gridDataComboFinFecha.horizontalSpan = 2;
		gridDataComboFinFecha.verticalAlignment = GridData.CENTER;
		comboFinFecha = new Combo(groupFin, SWT.READ_ONLY);
		comboFinFecha.setText("00/00/0000");
		comboFinFecha.setLayoutData(gridDataComboFinFecha);
		comboFinFecha.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				String idMateria=comboConIdMateriaClase.idSeleccionado();
				if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
					uHComboFin.rellenaUHMateriaClaseDesdeHora(idMateria, fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
				else
					uHComboFin.rellenaUHMateriaClaseDesdeHora(idMateria, fechaComboFin.fechaSeleccionada(),null);
				BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
						fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
						fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
				actualizarSoloListaEvaluables();
			}
			public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {
			}
		});
		fechaComboFin = new FechaCombo(comboFinFecha);
	}
	private void createComboFinHora() {
		GridData gridDataComboFinHora = new GridData();
		gridDataComboFinHora.horizontalAlignment = GridData.FILL;
		gridDataComboFinHora.grabExcessHorizontalSpace = true;
		gridDataComboFinHora.widthHint = 100;
		gridDataComboFinHora.verticalAlignment = GridData.CENTER;
		comboFinHora = new Combo(groupFin, SWT.READ_ONLY);
		comboFinHora.setText("00:00-00:00");
		comboFinHora.setLayoutData(gridDataComboFinHora);
		comboFinHora
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						BBDD.modificarFechaHoraEvaluable(listConIdEvaluables.idSeleccionado(),
								fechaComboInicio.fechaSeleccionada(),uHComboInicio.idSelecionado(),
								fechaComboFin.fechaSeleccionada(),uHComboFin.idSelecionado());
						actualizarSoloListaEvaluables();
					}
					public void widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent e) {}
				});
		uHComboFin = new UHCombo(comboFinHora);
	}
	private void createGroupEvaluaciones() {
		GridData gridDataGroupEvaluaciones = new GridData();
		gridDataGroupEvaluaciones.widthHint = 300;
		gridDataGroupEvaluaciones.horizontalAlignment = GridData.FILL;
		gridDataGroupEvaluaciones.grabExcessHorizontalSpace = true;
		gridDataGroupEvaluaciones.grabExcessVerticalSpace = true;
		gridDataGroupEvaluaciones.verticalSpan = 2;
		gridDataGroupEvaluaciones.verticalAlignment = GridData.FILL;
		GridLayout gridLayoutGroupEvaluaciones = new GridLayout();
		gridLayoutGroupEvaluaciones.horizontalSpacing = 2;
		gridLayoutGroupEvaluaciones.marginWidth = 2;
		gridLayoutGroupEvaluaciones.marginHeight = 2;
		gridLayoutGroupEvaluaciones.numColumns = 3;
		gridLayoutGroupEvaluaciones.verticalSpacing = 2;
		groupEvaluaciones = new Group(this, SWT.NONE);
		groupEvaluaciones.setText("Evaluaciones");
		groupEvaluaciones.setLayoutData(gridDataGroupEvaluaciones);
		groupEvaluaciones.setLayout(gridLayoutGroupEvaluaciones);
		createGroupEvaluacionesGrupo();
		createGroupEvaluacionesEstudiantes();
		labelEvaluacionesObservaciones = new Label(groupEvaluaciones, SWT.NONE);
		labelEvaluacionesObservaciones.setText("Observaciones:");
		labelEvaluacionesObservaciones.setToolTipText("Indique las observaciones pertinentes referentes a la evaluación.");
		GridData gridDataLabelEvaluacionesNota = new GridData();
		gridDataLabelEvaluacionesNota.grabExcessHorizontalSpace = true;
		gridDataLabelEvaluacionesNota.verticalAlignment = GridData.CENTER;
		gridDataLabelEvaluacionesNota.horizontalAlignment = GridData.END;
		labelEvaluacionesNota = new Label(groupEvaluaciones, SWT.NONE);
		labelEvaluacionesNota.setText("Nota:");
		labelEvaluacionesNota.setLayoutData(gridDataLabelEvaluacionesNota);
		labelEvaluacionesNota.setToolTipText("Nota obtenida por un estudiante sin grupo o por un grupo de estudiantes (todos ellos tendrán la misma nota).");
		textEvaluacionesNota = new Text(groupEvaluaciones, SWT.BORDER);
		textEvaluacionesNota.setToolTipText("Especifique aquí la nota obtenida por un estudiante sin grupo o por un grupo de estudiantes (todos ellos tendrán la misma nota).");
		TextoDemorado.add(textEvaluacionesNota,true,1,2,Numero.notaMax,true,listConIdEvaluacionesEstudiantes,listConIdEvaluables);
		GridData gridDataTextAreaEvaluacionesObservaciones = new GridData();
		gridDataTextAreaEvaluacionesObservaciones.horizontalSpan = 3;
		gridDataTextAreaEvaluacionesObservaciones.verticalAlignment = GridData.FILL;
		gridDataTextAreaEvaluacionesObservaciones.grabExcessHorizontalSpace = true;
		gridDataTextAreaEvaluacionesObservaciones.grabExcessVerticalSpace = true;
		gridDataTextAreaEvaluacionesObservaciones.horizontalAlignment = GridData.FILL;
		textAreaEvaluacionesObservaciones = new Text(groupEvaluaciones, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
		textAreaEvaluacionesObservaciones.setToolTipText("Indique aquí las observaciones pertinentes referentes a la evaluación.");
		textAreaEvaluacionesObservaciones.setLayoutData(gridDataTextAreaEvaluacionesObservaciones);
		TextoDemorado.add(textAreaEvaluacionesObservaciones,false,512,null,null,true,listConIdEvaluacionesEstudiantes,listConIdEvaluables);
	}
	private void createGroupEvaluacionesGrupo() {
		GridLayout gridLayoutGroupEvaluacionesGrupo = new GridLayout();
		gridLayoutGroupEvaluacionesGrupo.horizontalSpacing = 2;
		gridLayoutGroupEvaluacionesGrupo.marginWidth = 2;
		gridLayoutGroupEvaluacionesGrupo.marginHeight = 2;
		gridLayoutGroupEvaluacionesGrupo.numColumns = 3;
		gridLayoutGroupEvaluacionesGrupo.verticalSpacing = 2;
		GridData gridDataGroupEvaluacionesGrupo = new GridData();
		gridDataGroupEvaluacionesGrupo.widthHint = 100;
		gridDataGroupEvaluacionesGrupo.horizontalAlignment = GridData.FILL;
		gridDataGroupEvaluacionesGrupo.verticalSpan = 1;
		gridDataGroupEvaluacionesGrupo.horizontalSpan = 1;
		gridDataGroupEvaluacionesGrupo.grabExcessHorizontalSpace = true;
		gridDataGroupEvaluacionesGrupo.verticalAlignment = GridData.FILL;
		groupEvaluacionesGrupo = new Group(groupEvaluaciones, SWT.NONE);
		groupEvaluacionesGrupo.setLayoutData(gridDataGroupEvaluacionesGrupo);
		groupEvaluacionesGrupo.setLayout(gridLayoutGroupEvaluacionesGrupo);
		groupEvaluacionesGrupo.setText("Grupos");
		GridData gridDataListEvaluacionesGrupos = new GridData();
		gridDataListEvaluacionesGrupos.horizontalAlignment = GridData.FILL;
		gridDataListEvaluacionesGrupos.grabExcessVerticalSpace = true;
		gridDataListEvaluacionesGrupos.horizontalSpan = 3;
		gridDataListEvaluacionesGrupos.grabExcessHorizontalSpace = true;
		gridDataListEvaluacionesGrupos.heightHint = -1;
		gridDataListEvaluacionesGrupos.widthHint = -1;
		gridDataListEvaluacionesGrupos.verticalAlignment = GridData.FILL;
		listEvaluacionesGrupos = new List(groupEvaluacionesGrupo, SWT.BORDER | SWT.V_SCROLL);
		listEvaluacionesGrupos.setToolTipText("Elegir un grupo ha evaluar o elija 'Sin grupo' para poder seleccionar un estudiante no incluido en ningún grupo.");
		listEvaluacionesGrupos.setLayoutData(gridDataListEvaluacionesGrupos);
		listEvaluacionesGrupos
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						actualizarNombreNuevoBorrar();
						actualizarEstudiantesEvaluacion();
						comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos);
					}
				});
		listConIdEvaluacionesGrupos = new ListConId(listEvaluacionesGrupos);
		labelReferenciaGrupo = new Label(groupEvaluacionesGrupo, SWT.NONE);
		labelReferenciaGrupo.setText("Ref.:");
		GridData gridDataTextEvaluacionGrupoNombre = new GridData();
		gridDataTextEvaluacionGrupoNombre.horizontalAlignment = GridData.FILL;
		gridDataTextEvaluacionGrupoNombre.grabExcessHorizontalSpace = true;
		gridDataTextEvaluacionGrupoNombre.horizontalSpan = 2;
		gridDataTextEvaluacionGrupoNombre.verticalAlignment = GridData.CENTER;
		textEvaluacionGrupoNombre = new Text(groupEvaluacionesGrupo, SWT.BORDER);
		textEvaluacionGrupoNombre.setTextLimit(10);
		textEvaluacionGrupoNombre.setLayoutData(gridDataTextEvaluacionGrupoNombre);
		TextoDemorado.add(textEvaluacionGrupoNombre,false,10,null,null,false,listConIdEvaluacionesGrupos,null);
		GridData gridDataButtonEvaluacionesNuevoGrupo = new GridData();
		gridDataButtonEvaluacionesNuevoGrupo.horizontalSpan = 2;
		buttonEvaluacionesNuevoGrupo = new Button(groupEvaluacionesGrupo, SWT.NONE);
		buttonEvaluacionesNuevoGrupo.setText("Nuevo");
		buttonEvaluacionesNuevoGrupo.setLayoutData(gridDataButtonEvaluacionesNuevoGrupo);
		buttonEvaluacionesNuevoGrupo.setToolTipText("Pulse aquí para crear un grupo de estudiantes evaluados colectivamente.");buttonEvaluacionesNuevoGrupo
		.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Creando Evaluable");
				String idEval = BBDD.consultarIdEvalEstudianteEvaluable(
						listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado());
				int nEstudiantes = listConIdEvaluacionesEstudiantes.idSeleccionados().size();
				for (int i=1;i<nEstudiantes;i++) {
					BBDD.borrarEvalEvaluable(BBDD.consultarIdEvalEstudianteEvaluable(
							listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),
							listConIdEvaluables.idSeleccionado()));
				}
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Nuevo grupo a partir de "+idEval);
				if (idEval!=null) {
					BBDD.modificarGrupoEvalEvaluable(BBDD.expNuevoGrupoEvaluacion, idEval);
					for (int i=1;i<nEstudiantes;i++){
						BBDD.insertarEstudianteGrupoEvalEvaluable(listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),idEval);
					}
				} else {
					idEval = BBDD.insertarEvalEstudianteEvaluable(
							listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado(), 
							"0");
					BBDD.modificarGrupoEvalEvaluable(BBDD.expNuevoGrupoEvaluacion, idEval);
					for (int i=1;i<nEstudiantes;i++){
						BBDD.insertarEstudianteGrupoEvalEvaluable(listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),idEval);
					}
				}
				actualizarGrupoEvaluacion();
				listConIdEvaluacionesGrupos.seleccionarId(idEval);
				actualizarNombreNuevoBorrar();
				actualizarEstudiantesEvaluacion();
				comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos);
			}
		});
		GridData gridDataButtonEvaluacionesBorrarGrupo = new GridData();
		gridDataButtonEvaluacionesBorrarGrupo.horizontalAlignment = GridData.END;
		gridDataButtonEvaluacionesBorrarGrupo.verticalAlignment = GridData.CENTER;
		buttonEvaluacionesBorrarGrupo = new Button(groupEvaluacionesGrupo, SWT.NONE);
		buttonEvaluacionesBorrarGrupo.setText("Borrar");
		buttonEvaluacionesBorrarGrupo.setToolTipText("Pulse aquí para borrar un grupo de estudiantes evaluados colectivamente.");
		buttonEvaluacionesBorrarGrupo.setLayoutData(gridDataButtonEvaluacionesBorrarGrupo);
		buttonEvaluacionesBorrarGrupo
				.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						BBDD.borrarEvalEvaluable(BBDD.consultarIdEvalEstudianteEvaluable(
								listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado()));
						actualizarGrupoEvaluacion();
					}
				});
	}
	private void createGroupEvaluacionesEstudiantes() {
		GridLayout gridLayoutGroupEvaluacionesEstudiantes = new GridLayout();
		gridLayoutGroupEvaluacionesEstudiantes.horizontalSpacing = 2;
		gridLayoutGroupEvaluacionesEstudiantes.marginWidth = 2;
		gridLayoutGroupEvaluacionesEstudiantes.marginHeight = 2;
		gridLayoutGroupEvaluacionesEstudiantes.numColumns = 1;
		gridLayoutGroupEvaluacionesEstudiantes.verticalSpacing = 2;
		GridData gridDataGroupEvaluacionesEstudiantes = new GridData();
		gridDataGroupEvaluacionesEstudiantes.horizontalAlignment = GridData.FILL;
		gridDataGroupEvaluacionesEstudiantes.verticalSpan = 1;
		gridDataGroupEvaluacionesEstudiantes.horizontalSpan = 2;
		gridDataGroupEvaluacionesEstudiantes.grabExcessHorizontalSpace = true;
		gridDataGroupEvaluacionesEstudiantes.grabExcessVerticalSpace = true;
		gridDataGroupEvaluacionesEstudiantes.widthHint = 175;
		gridDataGroupEvaluacionesEstudiantes.verticalAlignment = GridData.FILL;
		groupEvaluacionesEstudiantes = new Group(groupEvaluaciones, SWT.NONE);
		groupEvaluacionesEstudiantes.setLayoutData(gridDataGroupEvaluacionesEstudiantes);
		groupEvaluacionesEstudiantes.setLayout(gridLayoutGroupEvaluacionesEstudiantes);
		groupEvaluacionesEstudiantes.setText("Estudiantes");
		groupEvaluacionesGrupo.setToolTipText("Si en grupos eligió 'Sin grupo' eliga aquí un estudiante para asignarle una nota. Si ha elegido un grupo aquí podrá elegir los estudiantes pertenecientes al grupo.");
		GridData gridDataListEvaluacionesEstudiantes = new GridData();
		gridDataListEvaluacionesEstudiantes.grabExcessHorizontalSpace = true;
		gridDataListEvaluacionesEstudiantes.horizontalAlignment = GridData.FILL;
		gridDataListEvaluacionesEstudiantes.verticalAlignment = GridData.FILL;
		gridDataListEvaluacionesEstudiantes.grabExcessVerticalSpace = true;
		gridDataListEvaluacionesEstudiantes.heightHint = 50;
		listEvaluacionesEstudiantes = new List(groupEvaluacionesEstudiantes, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
		listEvaluacionesEstudiantes.setToolTipText("Si en grupos eligió 'Sin grupo' eliga aquí un estudiante para asignarle una nota. Si ha elegido un grupo aquí podrá elegir los estudiantes pertenecientes al grupo.");
		listEvaluacionesEstudiantes.setLayoutData(gridDataListEvaluacionesEstudiantes);
		listEvaluacionesEstudiantes.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				actualizarNotaObservaciones();
			}
		});
		listConIdEvaluacionesEstudiantes = new ListConId(listEvaluacionesEstudiantes);
		GridData gridDataLabelEvaluacionesMoverA = new GridData();
		gridDataLabelEvaluacionesMoverA.horizontalAlignment = GridData.END;
		gridDataLabelEvaluacionesMoverA.verticalAlignment = GridData.CENTER;
		labelEvaluacionesMoverA = new Label(groupEvaluacionesEstudiantes, SWT.NONE);
		labelEvaluacionesMoverA.setText("Mover al grupo:");
		labelEvaluacionesMoverA.setLayoutData(gridDataLabelEvaluacionesMoverA);
		labelEvaluacionesMoverA.setToolTipText("Para mover los estudiantes seleccionados al grupo que elija acontinuación.");
		createComboEvaluacionesMoverA();
	}
	private void createComboEvaluacionesMoverA() {
		GridData gridDataComboEvaluacionesMoverA = new GridData();
		gridDataComboEvaluacionesMoverA.widthHint = 100;
		gridDataComboEvaluacionesMoverA.horizontalAlignment = GridData.FILL;
		gridDataComboEvaluacionesMoverA.verticalAlignment = GridData.CENTER;
		gridDataComboEvaluacionesMoverA.grabExcessHorizontalSpace = true;
		comboEvaluacionesMoverA = new Combo(groupEvaluacionesEstudiantes, SWT.READ_ONLY);
		comboEvaluacionesMoverA.setToolTipText("Seleccionando aquí un grupo moverá los estudiantes seleccionados al grupo elegido aquí.");
		comboEvaluacionesMoverA.setLayoutData(gridDataComboEvaluacionesMoverA);
		comboConIdEvaluacionesMoverA = new ComboConId(comboEvaluacionesMoverA);
		comboEvaluacionesMoverA
				.addSelectionListener(new org.eclipse.swt.events.SelectionListener() {
					public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
						if (comboEvaluacionesMoverA.getSelectionIndex()>=0)
							if (comboConIdEvaluacionesMoverA.idSeleccionado().equals("")
									&& comboConIdEvaluacionesMoverA.eSeleccionado().equals(BBDD.expNoMoverGrupo)) {
								comboEvaluacionesMoverA.select(-1);
							} else {
								if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Moviendo al grupo "+comboConIdEvaluacionesMoverA.eSeleccionado()+"("+comboConIdEvaluacionesMoverA.idSeleccionado()+") desde "+BBDD.expSinGrupoEvaluacion);
								String idEval = BBDD.consultarIdEvalEstudianteEvaluable(
										listConIdEvaluacionesEstudiantes.idSeleccionado(),listConIdEvaluables.idSeleccionado());
								// De donde viene quitar o borrar si viene de algun lado
								if (idEval!=null) {
									Vector<Vector<String>> estudiantes = BBDD.consultarEstudiantesEvalEvaluable(listConIdEvaluacionesGrupos.idSeleccionado());
									int ne = listConIdEvaluacionesEstudiantes.idSeleccionados().size();
									if (estudiantes.size()>ne) {
										for (int i=0;i<ne;i++){
											BBDD.borrarEstudianteGrupoEvalEvaluable(
													listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),
													listConIdEvaluacionesGrupos.idSeleccionado());
										}
									} else {
										BBDD.borrarEvalEvaluable(idEval);
										actualizarGrupoEvaluacion();
									}
								}
								// A donde va insertar
								idEval = comboConIdEvaluacionesMoverA.idSeleccionado();
								if (idEval==null) idEval="";// Va a sin grupo
								if (idEval.equals("")) {
									// Va a sin grupo se queda sin evaluación
								} else {
									int ne = listConIdEvaluacionesEstudiantes.idSeleccionados().size();
									for (int i=0;i<ne;i++){
										BBDD.insertarEstudianteGrupoEvalEvaluable(listConIdEvaluacionesEstudiantes.idSeleccionados().get(i),idEval);
									}
								}
								listConIdEvaluacionesGrupos.seleccionarId(idEval);
								actualizarNombreNuevoBorrar();
								actualizarEstudiantesEvaluacion();
								comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos);
							}
					}
					public void widgetDefaultSelected(
							org.eclipse.swt.events.SelectionEvent e) {
					}
				});
	}
	private void actualizarFechaEvaluables(){
		if (comboParcial.getSelectionIndex()>=0)
			fechaComboInicio.rellenarLectivosParcialDesdeFechaMateria(comboParcial.getSelectionIndex()+1,null, true);
		else fechaComboInicio.borrar();
		fechaComboInicio.deshabilitar();
	}
	public void actualizarListaEvaluables(String idSeleccionado){
		if (comboConIdMateriaClase.idSeleccionado()!=null && comboParcial.getSelectionIndex()>=0){
			actualizarSoloListaEvaluables();
			listConIdEvaluables.seleccionarId(idSeleccionado);
		} else {
			listConIdEvaluables.borrar();
		}
		actualizarDatosEvaluable(); 
	}
	public void actualizarSoloListaEvaluables(){
		listConIdEvaluables.rellenarEvaluables(comboConIdMateriaClase.idSeleccionado(),comboParcial.getSelectionIndex()+1);
	}
	private void actualizarDatosEvaluable(){
		if (listConIdEvaluables.idSeleccionado()==null){
			textReferencia.setEnabled(false);textReferencia.setText("");
			textPeso.setEnabled(false);textPeso.setText("");
			textAreaEnunciado.setEnabled(false);textAreaEnunciado.setText("");
			textAreaEvaluacionesObservaciones.setEnabled(false);textAreaEvaluacionesObservaciones.setText("");
			textEvaluacionesNota.setEnabled(false);textEvaluacionesNota.setText("");
			comboConIdTipo.deshabilitar();
			fechaComboInicio.seleccionarPrimera();
			fechaComboInicio.deshabilitar();
			fechaComboFin.borrar();uHComboInicio.getCombo().setEnabled(false);
			uHComboInicio.borrar();fechaComboFin.deshabilitar();
			uHComboFin.borrar();uHComboFin.getCombo().setEnabled(false);
			listConIdEvaluacionesEstudiantes.deshabilitar();
			listConIdEvaluacionesGrupos.borrar();listConIdEvaluacionesGrupos.deshabilitar();
			textEvaluacionGrupoNombre.setEnabled(false);textEvaluacionGrupoNombre.setText("");
			comboEvaluacionesMoverA.setEnabled(false);
			buttonEvaluacionesBorrarGrupo.setEnabled(false);
			buttonEvaluacionesNuevoGrupo.setEnabled(false);
			buttonBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> evaluable;
			TextoDemorado.escribeSiHay();
			evaluable=BBDD.consultarEvaluable(listConIdEvaluables.idSeleccionado());
			TextoDemorado.modificaSinActualizar(textReferencia,evaluable.get(0).get(9));
			TextoDemorado.modificaSinActualizar(textPeso,evaluable.get(0).get(11));
			comboConIdTipo.seleccionarId(evaluable.get(0).get(12));comboTipo.setEnabled(true);
			TextoDemorado.modificaSinActualizar(textAreaEnunciado,evaluable.get(0).get(10));textAreaEnunciado.setEnabled(true);
			//System.out.println("actualizarDatosEvaluable fecha "+Fecha.formaFecha(evaluable.get(0).get(3),evaluable.get(0).get(2),evaluable.get(0).get(1)));
			fechaComboInicio.seleccionarFecha(Fecha.fecha(evaluable.get(0).get(3),evaluable.get(0).get(2),evaluable.get(0).get(1)));
			fechaComboInicio.habilitar();
			uHComboInicio.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboInicio.fechaSeleccionada(),null);
			uHComboInicio.seleccionarId(evaluable.get(0).get(4));
			uHComboInicio.getCombo().setEnabled(true);
			fechaComboFin.rellenarLectivosParcialDesdeFechaMateria(comboParcial.getSelectionIndex()+1,fechaComboInicio.fechaSeleccionada(),true);
			fechaComboFin.seleccionarFecha(Fecha.fecha(evaluable.get(0).get(7),evaluable.get(0).get(6),evaluable.get(0).get(5)));
			fechaComboFin.habilitar();
			if (fechaComboInicio.fechaSeleccionada().compareTo(fechaComboFin.fechaSeleccionada())==0)
				uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),uHComboInicio.idSelecionado());
			else
				uHComboFin.rellenaUHMateriaClaseDesdeHora(MateriaClase.getIdMateriaClaseDeTrabajo(), fechaComboFin.fechaSeleccionada(),null);
			uHComboFin.seleccionarId(evaluable.get(0).get(8));
			uHComboFin.getCombo().setEnabled(true);
			actualizarGrupoEvaluacion();
			listConIdEvaluacionesGrupos.habilitar();
			listConIdEvaluacionesEstudiantes.habilitar();
			actualizarNotaObservaciones();
			buttonBorrar.setEnabled(true);
			//System.out.println("Evaluable Mat ("+idMateria+"): ini "+Fecha.formaFecha(evaluable.get(0).get(3),evaluable.get(0).get(2),evaluable.get(0).get(1))+" - "+evaluable.get(0).get(4)+
			//		", fin "+Fecha.formaFecha(evaluable.get(0).get(7),evaluable.get(0).get(6),evaluable.get(0).get(5))+" - "+evaluable.get(0).get(8));
		}
	}
	private void actualizarEstudiantesEvaluacion(){
		if (listConIdEvaluacionesGrupos.idSeleccionado()!=null){
			listConIdEvaluacionesEstudiantes.rellenarEstudiantesGrupoEval(listConIdEvaluables.idSeleccionado(),listConIdEvaluacionesGrupos.idSeleccionado());
		} else {
			listConIdEvaluacionesEstudiantes.borrar();
		}
		actualizarNotaObservaciones();
	}
	public void actualizarGrupoEvaluacion(){
		String idAntiguo = listConIdEvaluacionesGrupos.idSeleccionado();
		listConIdEvaluacionesGrupos.borrar();
		listConIdEvaluacionesGrupos.rellenarGrupoEvalEvaluable(listConIdEvaluables.idSeleccionado());
		if (idAntiguo!=null) listConIdEvaluacionesGrupos.seleccionarId(idAntiguo);
		actualizarNombreNuevoBorrar();
		actualizarEstudiantesEvaluacion();
		comboConIdEvaluacionesMoverA.rellenarConListaSalvoSeleccionado(listConIdEvaluacionesGrupos);
		if (comboConIdEvaluacionesMoverA.numeroElementos()>0) comboConIdEvaluacionesMoverA.habilitar(); 
		else comboConIdEvaluacionesMoverA.deshabilitar();
	}
	public void actualizarNotaObservaciones(){
		if (listConIdEvaluacionesEstudiantes.idSeleccionados().size()>1) {
			TextoDemorado.modificaSinActualizar(textEvaluacionesNota, "");
			textEvaluacionesNota.setEnabled(false);
		} else {
			textEvaluacionesNota.setEnabled(true);
			String nota = BBDD.consultarEvalNota(listConIdEvaluables.idSeleccionado(),listConIdEvaluacionesEstudiantes.idSeleccionado());
			if (nota!=null) {
				TextoDemorado.modificaSinActualizar(textEvaluacionesNota,Numero.cadenaDecimal(Double.parseDouble(nota)));
				TextoDemorado.modificaSinActualizar(textAreaEvaluacionesObservaciones,
						BBDD.consultarEvalObservaciones(listConIdEvaluables.idSeleccionado(),listConIdEvaluacionesEstudiantes.idSeleccionado()));
			} else {
				TextoDemorado.modificaSinActualizar(textEvaluacionesNota,"");
				TextoDemorado.modificaSinActualizar(textAreaEvaluacionesObservaciones, "");textAreaEvaluacionesObservaciones.setEnabled(false);
			}
		}
	}
	private void actualizarNombreNuevoBorrar(){ // Sin grupo => id=""
		if (((listConIdEvaluacionesGrupos.idSeleccionado()==null)?true:listConIdEvaluacionesGrupos.idSeleccionado().isEmpty())){
			TextoDemorado.modificaSinActualizar(textEvaluacionGrupoNombre,"");
			textEvaluacionGrupoNombre.setEnabled(false);
			buttonEvaluacionesBorrarGrupo.setEnabled(false);
			buttonEvaluacionesNuevoGrupo.setEnabled(true);
		} else {
			TextoDemorado.modificaSinActualizar(textEvaluacionGrupoNombre,listConIdEvaluacionesGrupos.elementoSeleccionado());
			buttonEvaluacionesBorrarGrupo.setEnabled(true);
			buttonEvaluacionesNuevoGrupo.setEnabled(false);
		}
	}
}
