/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Display;

public class MinutoCombo {
	static final int incrementoMinutos=5;
	private final static Color colorNoValido = Display.getCurrent().getSystemColor(SWT.COLOR_RED);
	private Color color=null;
	private Combo objetoCombo=null;
	private Vector<Integer> valores = new Vector<Integer>();
	
	public MinutoCombo(Combo combo){this.objetoCombo=combo;this.color=objetoCombo.getForeground();}
	
	public void borrar(){this.objetoCombo.removeAll();this.valores.clear();}
	public void valido(boolean valor){objetoCombo.setForeground(((valor)?color:colorNoValido));}
	public void deshabilitar(){this.objetoCombo.setEnabled(false);}
	public void habilitar(){this.objetoCombo.setEnabled(true);}
	public String minutoSeleccionada(){return ((this.objetoCombo.getSelectionIndex()>=0)?String.valueOf(valores.get(this.objetoCombo.getSelectionIndex())):null);}
	public void seleccionarMinuto(String minuto){
		Integer vHora=Integer.parseInt(minuto);
		if (minuto!=null) {
			int indUltMinuto=valores.size()-1;
			if (indUltMinuto>=0) {
				if (indUltMinuto==0) this.objetoCombo.select(0);
				else if (vHora<=valores.get(0)) this.objetoCombo.select(0);
				else if (vHora>=valores.get(indUltMinuto)) this.objetoCombo.select(indUltMinuto);
				else {
					for (int i=0;i<indUltMinuto;i++) {
						if (vHora<=valores.get(i)) {this.objetoCombo.select(i);break;}
					}
				}
			}
		}
		if (this.objetoCombo.getSelectionIndex()<0 && this.objetoCombo.getItemCount()>0) this.objetoCombo.select(0);
	}
	public void rellena(){
		this.borrar();
		for (int i=0;i<60;i+=incrementoMinutos) {
			this.objetoCombo.add(String.format("%02d",i));
			this.valores.add(i);
		}
		this.objetoCombo.select(0);
	}
}
